pcl::PFHEstimation< PointInT, PointNT, PointOutT > Class Template Reference
Module features

PFHEstimation estimates the Point Feature Histogram (PFH) descriptor for a given point cloud dataset containing points and normals. More...

`#include <pcl/features/pfh.h>`

Inheritance diagram for pcl::PFHEstimation< PointInT, PointNT, PointOutT >:

## Public Types

typedef boost::shared_ptr< PFHEstimation< PointInT, PointNT, PointOutT > > | Ptr
typedef boost::shared_ptr< const PFHEstimation< PointInT, PointNT, PointOutT > > | ConstPtr
typedef Feature< PointInT, PointOutT >::PointCloudOut | PointCloudOut
typedef Feature< PointInT, PointOutT >::PointCloudIn | PointCloudIn
Public Types inherited from pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >
typedef pcl::PointCloud< PointNT > | PointCloudN
typedef PointCloudN::Ptr | PointCloudNPtr
typedef PointCloudN::ConstPtr | PointCloudNConstPtr
typedef boost::shared_ptr< FeatureFromNormals< PointInT, PointNT, PointOutT > > | Ptr
typedef boost::shared_ptr< const FeatureFromNormals< PointInT, PointNT, PointOutT > > | ConstPtr
Public Types inherited from pcl::Feature< PointInT, PointOutT >
typedef PCLBase< PointInT > | BaseClass
typedef boost::shared_ptr< Feature< PointInT, PointOutT > > | Ptr
typedef boost::shared_ptr< const Feature< PointInT, PointOutT > > | ConstPtr
typedef pcl::search::Search< PointInT > | KdTree
typedef pcl::search::Search< PointInT >::Ptr | KdTreePtr
typedef pcl::PointCloud< PointInT > | PointCloudIn
typedef PointCloudIn::Ptr | PointCloudInPtr
typedef PointCloudIn::ConstPtr | PointCloudInConstPtr
typedef pcl::PointCloud< PointOutT > | PointCloudOut
typedef boost::function< int(size_t, double, std::vector< int > &, std::vector< float > &)> | SearchMethod
typedef boost::function< int(const PointCloudIn &cloud, size_t index, double, std::vector< int > &, std::vector< float > &)> | SearchMethodSurface
Public Types inherited from pcl::PCLBase< PointInT >
typedef pcl::PointCloud< PointInT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| PFHEstimation ()
| Empty constructor. More...
void | setMaximumCacheSize (unsigned int cache_size)
| Set the maximum internal cache size. More...
unsigned int | getMaximumCacheSize ()
| Get the maximum internal cache size. More...
void | setUseInternalCache (bool use_cache)
| Set whether to use an internal cache mechanism for removing redundant calculations or not. More...
bool | getUseInternalCache ()
| Get whether the internal cache is used or not for computing the PFH features. More...
bool | computePairFeatures (const pcl::PointCloud< PointInT > &cloud, const pcl::PointCloud< PointNT > &normals, int p_idx, int q_idx, float &f1, float &f2, float &f3, float &f4)
| Compute the 4-tuple representation containing the three angles and one distance between two points represented by Cartesian coordinates and normals. More...
void | computePointPFHSignature (const pcl::PointCloud< PointInT > &cloud, const pcl::PointCloud< PointNT > &normals, const std::vector< int > &indices, int nr_split, Eigen::VectorXf &pfh_histogram)
| Estimate the PFH (Point Feature Histograms) individual signatures of the three angular (f1, f2, f3) features for a given point based on its spatial neighborhood of 3D points with normals. More...
Public Member Functions inherited from pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >
| FeatureFromNormals ()
| Empty constructor. More...
virtual | ~FeatureFromNormals ()
| Empty destructor. More...
void | setInputNormals (const PointCloudNConstPtr &normals)
| Provide a pointer to the input dataset that contains the point normals of the XYZ dataset. More...
PointCloudNConstPtr | getInputNormals () const
| Get a pointer to the normals of the input XYZ point cloud dataset. More...
Public Member Functions inherited from pcl::Feature< PointInT, PointOutT >
| Feature ()
| Empty constructor. More...
virtual | ~Feature ()
| Empty destructor. More...
void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to a dataset to add additional information to estimate the features for every point in the input dataset. More...
PointCloudInConstPtr | getSearchSurface () const
| Get a pointer to the surface point cloud dataset. More...
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object. More...
KdTreePtr | getSearchMethod () const
| Get a pointer to the search method used. More...
double | getSearchParameter () const
| Get the internal search parameter. More...
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation. More...
int | getKSearch () const
| get the number of k nearest neighbors used for the feature estimation. More...
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the feature estimation. More...
double | getRadiusSearch () const
| Get the sphere radius used for determining the neighbors. More...
void | compute (PointCloudOut &output)
| Base method for feature estimation for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod () More...
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointInT & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

void | computeFeature (PointCloudOut &output)
| Estimate the Point Feature Histograms (PFH) descriptors at a set of points given by <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod () More...
Protected Member Functions inherited from pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >
virtual bool | initCompute ()
| This method should get called before starting the actual computation. More...
Protected Member Functions inherited from pcl::Feature< PointInT, PointOutT >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
virtual bool | deinitCompute ()
| This method should get called after ending the actual computation. More...
int | searchForNeighbors (size_t index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
int | searchForNeighbors (const PointCloudIn &cloud, size_t index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Protected Attributes

int | nr_subdiv_
| The number of subdivisions for each angular feature interval. More...
Eigen::VectorXf | pfh_histogram_
| Placeholder for a point's PFH signature. More...
Eigen::Vector4f | pfh_tuple_
| Placeholder for a PFH 4-tuple. More...
int | f_index_ [3]
| Placeholder for a histogram index. More...
float | d_pi_
| Float constant = 1.0 / (2.0 * M_PI) More...
std::map< std::pair< int, int >, Eigen::Vector4f, std::less< std::pair< int, int > >, Eigen::aligned_allocator< std::pair< const std::pair< int, int >, Eigen::Vector4f > > > | feature_map_
| Internal hashmap, used to optimize efficiency of redundant computations. More...
std::queue< std::pair< int, int > > | key_list_
| Queue of pairs saved, used to constrain memory usage. More...
unsigned int | max_cache_size_
| Maximum size of internal cache memory. More...
bool | use_cache_
| Set to true to use the internal cache for removing redundant computations. More...
Protected Attributes inherited from pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >
PointCloudNConstPtr | normals_
| A pointer to the input dataset that contains the point normals of the XYZ dataset. More...
Protected Attributes inherited from pcl::Feature< PointInT, PointOutT >
std::string | feature_name_
| The feature name. More...
SearchMethodSurface | search_method_surface_
| The search method template for points. More...
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation. More...
KdTreePtr | tree_
| A pointer to the spatial search object. More...
double | search_parameter_
| The actual search parameter (from either search_radius_ or k_). More...
double | search_radius_
| The nearest neighbors search radius for each point. More...
int | k_
| The number of K nearest neighbors to use for each point. More...
bool | fake_surface_
| If no surface is given, we use the input PointCloud as the surface. More...
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointInT, typename PointNT, typename PointOutT = pcl::PFHSignature125>
class pcl::PFHEstimation< PointInT, PointNT, PointOutT >

PFHEstimation estimates the Point Feature Histogram (PFH) descriptor for a given point cloud dataset containing points and normals.

A commonly used type for PointOutT is pcl::PFHSignature125.

Note
  If you use this code in any academic work, please cite:

- R.B. Rusu, N. Blodow, Z.C. Marton, M. Beetz. Aligning Point Cloud Views using Persistent Feature Histograms. In Proceedings of the 21st IEEE/RSJ International Conference on Intelligent Robots and Systems (IROS), Nice, France, September 22-26 2008.
- R.B. Rusu, Z.C. Marton, N. Blodow, M. Beetz. Learning Informative Point Classes for the Acquisition of Object Model Maps. In Proceedings of the 10th International Conference on Control, Automation, Robotics and Vision (ICARCV), Hanoi, Vietnam, December 17-20 2008.

Attention
  The convention for PFH features is:
  - if a query point's nearest neighbors cannot be estimated, the PFH feature will be set to NaN (not a number)
  - it is impossible to estimate a PFH descriptor for a point that doesn't have finite 3D coordinates. Therefore, any point that contains NaN data on x, y, or z, will have its PFH feature property set to NaN.

Note
  The code is stateful as we do not expect this class to be multicore parallelized. Please look at FPFHEstimationOMP for examples on parallel implementations of the FPFH (Fast Point Feature Histogram).

Author
  Radu B. Rusu

Definition at line 82 of file pfh.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointInT , typename PointNT , typename PointOutT = pcl::PFHSignature125>

typedef boost::shared_ptr<const PFHEstimation<PointInT, PointNT, PointOutT> > pcl::PFHEstimation< PointInT, PointNT, PointOutT >::ConstPtr

Definition at line 86 of file pfh.h.

## PointCloudIn

template<typename PointInT , typename PointNT , typename PointOutT = pcl::PFHSignature125>

typedef Feature<PointInT, PointOutT>::PointCloudIn pcl::PFHEstimation< PointInT, PointNT, PointOutT >::PointCloudIn

Definition at line 97 of file pfh.h.

## PointCloudOut

template<typename PointInT , typename PointNT , typename PointOutT = pcl::PFHSignature125>

typedef Feature<PointInT, PointOutT>::PointCloudOut pcl::PFHEstimation< PointInT, PointNT, PointOutT >::PointCloudOut

Definition at line 96 of file pfh.h.

## Ptr

template<typename PointInT , typename PointNT , typename PointOutT = pcl::PFHSignature125>

typedef boost::shared_ptr<PFHEstimation<PointInT, PointNT, PointOutT> > pcl::PFHEstimation< PointInT, PointNT, PointOutT >::Ptr

Definition at line 85 of file pfh.h.

## Constructor & Destructor Documentation

## PFHEstimation()

template<typename PointInT , typename PointNT , typename PointOutT = pcl::PFHSignature125>

pcl::PFHEstimation< PointInT, PointNT, PointOutT >::PFHEstimation | ( |  | ) |

inline

Empty constructor.

Sets use_cache_ to false, nr_subdiv_ to 5, and the internal maximum cache size to 1GB.

Definition at line 102 of file pfh.h.

References pcl::Feature< PointInT, PointOutT >::feature_name_.

## Member Function Documentation

## computeFeature()

template<typename PointInT , typename PointNT , typename PointOutT >

void pcl::PFHEstimation< PointInT, PointNT, PointOutT >::computeFeature | ( | PointCloudOut & | output | ) |

protected virtual

Estimate the Point Feature Histograms (PFH) descriptors at a set of points given by <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod ()

Parameters

  [out] | output | the resultant point cloud model dataset that contains the PFH feature estimates

Implements pcl::Feature< PointInT, PointOutT >.

Definition at line 164 of file pfh.hpp.

References pcl::PointCloud< PointT >::is_dense, pcl::isFinite(), and pcl::PointCloud< PointT >::points.

Referenced by pcl::PFHEstimation< PointInT, PointNT, PointOutT >::getUseInternalCache().

## computePairFeatures()

template<typename PointInT , typename PointNT , typename PointOutT >

bool pcl::PFHEstimation< PointInT, PointNT, PointOutT >::computePairFeatures | ( | const pcl::PointCloud< PointInT > & | cloud,
|  | const pcl::PointCloud< PointNT > & | normals,
|  | int | p_idx,
|  | int | q_idx,
|  | float & | f1,
|  | float & | f2,
|  | float & | f3,
|  | float & | f4
| ) |  |

Compute the 4-tuple representation containing the three angles and one distance between two points represented by Cartesian coordinates and normals.

Note
  For explanations about the features, please see the literature mentioned above (the order of the features might be different).

Parameters

  [in] | cloud | the dataset containing the XYZ Cartesian coordinates of the two points
  [in] | normals | the dataset containing the surface normals (assuming normalized vectors) at each point in cloud
  [in] | p_idx | the index of the first point (source)
  [in] | q_idx | the index of the second point (target)
  [out] | f1 | the first angular feature (angle between the projection of nq_idx and u)
  [out] | f2 | the second angular feature (angle between nq_idx and v)
  [out] | f3 | the third angular feature (angle between np_idx and |p_idx - q_idx|)
  [out] | f4 | the distance feature (p_idx - q_idx)

Note
  For efficiency reasons, we assume that the point data passed to the method is finite.

Definition at line 46 of file pfh.hpp.

References pcl::computePairFeatures(), and pcl::PointCloud< PointT >::points.

Referenced by pcl::PFHEstimation< PointInT, PointNT, PointOutT >::getUseInternalCache().

## computePointPFHSignature()

template<typename PointInT , typename PointNT , typename PointOutT >

void pcl::PFHEstimation< PointInT, PointNT, PointOutT >::computePointPFHSignature | ( | const pcl::PointCloud< PointInT > & | cloud,
|  | const pcl::PointCloud< PointNT > & | normals,
|  | const std::vector< int > & | indices,
|  | int | nr_split,
|  | Eigen::VectorXf & | pfh_histogram
| ) |  |

Estimate the PFH (Point Feature Histograms) individual signatures of the three angular (f1, f2, f3) features for a given point based on its spatial neighborhood of 3D points with normals.

Parameters

  [in] | cloud | the dataset containing the XYZ Cartesian coordinates of the two points
  [in] | normals | the dataset containing the surface normals at each point in cloud
  [in] | indices | the k-neighborhood point indices in the dataset
  [in] | nr_split | the number of subdivisions for each angular feature interval
  [out] | pfh_histogram | the resultant (combinatorial) PFH histogram representing the feature at the query point

Definition at line 58 of file pfh.hpp.

References pcl::computePairFeatures(), pcl::isFinite(), and pcl::PointCloud< PointT >::points.

Referenced by pcl::PFHEstimation< PointInT, PointNT, PointOutT >::getUseInternalCache().

## getMaximumCacheSize()

template<typename PointInT , typename PointNT , typename PointOutT = pcl::PFHSignature125>

unsigned int pcl::PFHEstimation< PointInT, PointNT, PointOutT >::getMaximumCacheSize | ( |  | ) |

inline

Get the maximum internal cache size.

Definition at line 127 of file pfh.h.

References pcl::PFHEstimation< PointInT, PointNT, PointOutT >::max_cache_size_.

## getUseInternalCache()

template<typename PointInT , typename PointNT , typename PointOutT = pcl::PFHSignature125>

bool pcl::PFHEstimation< PointInT, PointNT, PointOutT >::getUseInternalCache | ( |  | ) |

inline

Get whether the internal cache is used or not for computing the PFH features.

Definition at line 151 of file pfh.h.

References pcl::PFHEstimation< PointInT, PointNT, PointOutT >::computeFeature(), pcl::PFHEstimation< PointInT, PointNT, PointOutT >::computePairFeatures(), pcl::PFHEstimation< PointInT, PointNT, PointOutT >::computePointPFHSignature(), and pcl::PFHEstimation< PointInT, PointNT, PointOutT >::use_cache_.

## setMaximumCacheSize()

template<typename PointInT , typename PointNT , typename PointOutT = pcl::PFHSignature125>

void pcl::PFHEstimation< PointInT, PointNT, PointOutT >::setMaximumCacheSize | ( | unsigned int | cache_size | ) |

inline

Set the maximum internal cache size.

Defaults to 2GB worth of entries.

Parameters

  [in] | cache_size | maximum cache size

Definition at line 120 of file pfh.h.

References pcl::PFHEstimation< PointInT, PointNT, PointOutT >::max_cache_size_.

## setUseInternalCache()

template<typename PointInT , typename PointNT , typename PointOutT = pcl::PFHSignature125>

void pcl::PFHEstimation< PointInT, PointNT, PointOutT >::setUseInternalCache | ( | bool | use_cache | ) |

inline

Set whether to use an internal cache mechanism for removing redundant calculations or not.

Note
  Depending on how the point cloud is ordered and how the nearest neighbors are estimated, using a cache could have a positive or a negative influence. Please test with and without a cache on your data, and choose whatever works best!

See setMaximumCacheSize for setting the maximum cache size

Parameters

  [in] | use_cache | set to true to use the internal cache, false otherwise

Definition at line 144 of file pfh.h.

References pcl::PFHEstimation< PointInT, PointNT, PointOutT >::use_cache_.

## Member Data Documentation

## d_pi_

template<typename PointInT , typename PointNT , typename PointOutT = pcl::PFHSignature125>

float pcl::PFHEstimation< PointInT, PointNT, PointOutT >::d_pi_

protected

Float constant = 1.0 / (2.0 * M_PI)

Definition at line 208 of file pfh.h.

## f_index_

template<typename PointInT , typename PointNT , typename PointOutT = pcl::PFHSignature125>

int pcl::PFHEstimation< PointInT, PointNT, PointOutT >::f_index_[3]

protected

Placeholder for a histogram index.

Definition at line 205 of file pfh.h.

## feature_map_

template<typename PointInT , typename PointNT , typename PointOutT = pcl::PFHSignature125>

std::map<std::pair<int, int>, Eigen::Vector4f, std::less<std::pair<int, int> >, Eigen::aligned_allocator<std::pair<const std::pair<int, int>, Eigen::Vector4f> > > pcl::PFHEstimation< PointInT, PointNT, PointOutT >::feature_map_

protected

Internal hashmap, used to optimize efficiency of redundant computations.

Definition at line 211 of file pfh.h.

## key_list_

template<typename PointInT , typename PointNT , typename PointOutT = pcl::PFHSignature125>

std::queue<std::pair<int, int> > pcl::PFHEstimation< PointInT, PointNT, PointOutT >::key_list_

protected

Queue of pairs saved, used to constrain memory usage.

Definition at line 214 of file pfh.h.

## max_cache_size_

template<typename PointInT , typename PointNT , typename PointOutT = pcl::PFHSignature125>

unsigned int pcl::PFHEstimation< PointInT, PointNT, PointOutT >::max_cache_size_

protected

Maximum size of internal cache memory.

Definition at line 217 of file pfh.h.

Referenced by pcl::PFHEstimation< PointInT, PointNT, PointOutT >::getMaximumCacheSize(), and pcl::PFHEstimation< PointInT, PointNT, PointOutT >::setMaximumCacheSize().

## nr_subdiv_

template<typename PointInT , typename PointNT , typename PointOutT = pcl::PFHSignature125>

int pcl::PFHEstimation< PointInT, PointNT, PointOutT >::nr_subdiv_

protected

The number of subdivisions for each angular feature interval.

Definition at line 196 of file pfh.h.

## pfh_histogram_

template<typename PointInT , typename PointNT , typename PointOutT = pcl::PFHSignature125>

Eigen::VectorXf pcl::PFHEstimation< PointInT, PointNT, PointOutT >::pfh_histogram_

protected

Placeholder for a point's PFH signature.

Definition at line 199 of file pfh.h.

## pfh_tuple_

template<typename PointInT , typename PointNT , typename PointOutT = pcl::PFHSignature125>

Eigen::Vector4f pcl::PFHEstimation< PointInT, PointNT, PointOutT >::pfh_tuple_

protected

Placeholder for a PFH 4-tuple.

Definition at line 202 of file pfh.h.

## use_cache_

template<typename PointInT , typename PointNT , typename PointOutT = pcl::PFHSignature125>

bool pcl::PFHEstimation< PointInT, PointNT, PointOutT >::use_cache_

protected

Set to true to use the internal cache for removing redundant computations.

Definition at line 220 of file pfh.h.

Referenced by pcl::PFHEstimation< PointInT, PointNT, PointOutT >::getUseInternalCache(), and pcl::PFHEstimation< PointInT, PointNT, PointOutT >::setUseInternalCache().

The documentation for this class was generated from the following files:

- /build/pcl-OilVEB/pcl-1.8.1+dfsg1/features/include/pcl/features/pfh.h
- /build/pcl-OilVEB/pcl-1.8.1+dfsg1/features/include/pcl/features/impl/pfh.hpp